//Spirale3D_401d.js
// 23.01.14 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Zeichnet eine 3D-Spirale

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// testen, ob ein Objekt ausgewhlt ist
if (app.selection.length == 0) {
	alert ("Bitte einen Rahmen auswhlen.", "Achtung");
	exit();
}

// das aktuelle Dokument
var curDoc = app.documents[0];

// Masseinheiten, Linealursprung und Nullpunkt speichern
hM = curDoc.viewPreferences.horizontalMeasurementUnits;
vM = curDoc.viewPreferences.verticalMeasurementUnits;
rO = curDoc.viewPreferences.rulerOrigin;
zP = curDoc.zeroPoint;
tR = curDoc.layoutWindows[0].transformReferencePoint;

// Einstellungen ndern
curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
curDoc.viewPreferences.rulerOrigin = RulerOrigin.SPREAD_ORIGIN;
curDoc.zeroPoint = [0,0];
curDoc.layoutWindows[0].transformReferencePoint = AnchorPoint.leftCenterAnchor;

// die Abmessungen der Auswahl speichern
try {
	var gB = app.selection[0].geometricBounds;
}
catch (e) {
	alert ("Bitte einen rechteckigen Rahmen auswhlen.", "Stop");
	reStoreSettings();
	exit();
}

// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
var allPrefs = getPrefs();
ck01 = ck02 = 0;
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	strW = prefVal[0]*1;
	strT = prefVal[1]*1;
	numV = prefVal[2]*1;
	pcHg = prefVal[3]*1;
	pcWd = prefVal[4]*1;
	rb01 = prefVal[5]*1;
	if (rb01 == 0) {
		ck01 = 1;
	}
	else {
		ck02 = 1;
	}
}
else {
	// wenn die Prferenzen-Datei nicht gefunden wurde
	// dann auf die Vorgabenwerte zurckgreifen
	strW = 1;
	strT = 100;
	numV = 10;
	pcHg = 60;
	pcWd = 90;
	ck01 = 1;
	ck02 = 0;
}

// die Funktion aufrufen, welche den Dialog zeigt und das Ergebnis zurckgibt
var anArray = displayDialog();
var strW    = anArray[0];
var strT    = anArray[1];
var numVal  = anArray[2];
var pcHeig  = anArray[3];
var pcWidt  = anArray[4];
var dirDec  = anArray[5];

// die Positionen y1, x1, x2
var y1 = (Math.floor((gB[0]*1000)+0.5))/1000;
var x1 = (Math.floor((gB[1]*1000)+0.5))/1000;
var y2 = (Math.floor((gB[2]*1000)+0.5))/1000;
var x2 = (Math.floor((gB[3]*1000)+0.5))/1000;

// die horizontale Mitte des Objekts
var m1 = x1 + ((x2-x1)/2);

// die Anzahl Runden ausrechnen
var nRounds = (Math.ceil(numVal/2))-1;
	
// einen Array vorbereiten
var allFrames = new Array ();

// einen ovalen Rahmen erzeugen ...
var baseOne = app.activeWindow.activePage.ovals.add();
baseOne.properties = {geometricBounds:[y1, x1, y2, x2], fillColor:"None", strokeColor:"None"};
//... und an den Array anfgen
allFrames.push(baseOne);

// den Pfad ffnen
baseOne.paths[0].pathType = PathType.OPEN_PATH;

// den letzten Pfadpunkt entfernen; Ergebnis: ein Halbbogen
baseOne.paths[0].pathPoints[3].remove();

if (numVal > 1) {
	// die Position des linken Halbbogens errechnen
	var yb1 = y1 + (((y2-y1)/100)*(100-pcHeig));
	
	// den Halbbogen duplizieren ...
	var baseTwo = baseOne.duplicate(undefined, [0, 0]);
	// ... und an den Array anfgen
	allFrames.push(baseTwo);
	
	// die Kopie spiegeln
	baseTwo.flipItem(Flip.HORIZONTAL);
	
	// die Kopie vertikal stauchen
	var gB = baseTwo.geometricBounds;
	var xb1 = gB[1];
	var yb2 = gB[2];
	baseTwo.geometricBounds = [yb1, xb1, yb2, m1];
	
	var frameA = baseOne;
	var frameB = baseTwo;
	var ya1 = yb1;
	
	// in einer Schleife die Basis-Halbbogen duplizieren und verndern
	for (var n=0; n<nRounds; n++) {
	
		// den ersten Halbbogen duplizieren ...
		var frameA = frameA.duplicate([m1, ya1]);
		// ... und an den Array anfgen
		allFrames.push(frameA);
		
		// die Kopie verndern
		var gB = frameA.geometricBounds;
		ya1 = gB[0];
		xa2 = m1+((gB[3]-m1)/100)*pcWidt;
		ya2 = ya1+((gB[2]-ya1)/100)*pcWidt;
		frameA.geometricBounds = [ya1, m1, ya2, xa2];
		
		// bei einer ungerade Anzahl vor dem letzten aussteigen
		if (numVal%2 == 1) {
			if (n == nRounds-1) {
				break;
			}
		}
		 
		try {
			// den zweiten Halbbogen duplizieren
			var frameB = frameB.duplicate([m1, ya2-(yb2-yb1)]);
			// die Kopie verndern ...
			var gB = frameB.geometricBounds;
			yb1 = gB[2]-((gB[2]-gB[0])/100)*pcWidt;
			xb1 = m1-((m1-gB[1])/100)*pcWidt;
			yb2 = gB[2];
			frameB.geometricBounds = [yb1, xb1, yb2, m1];
			// ... und an den Array anfgen
			allFrames.push(frameB);
			var ya1 = yb1;
		}
		catch (e) {
			frameA.remove();
		}
	}
	
	// die Endpunkte verbinden
	for (var n=1; n<allFrames.length; n++) {
		if (n%2 == 0) {
			try {
				allFrames[0].paths[0].pathPoints[0].join(allFrames[n].paths[0].pathPoints[2], JoinOptions.COMBINE);
			}
			catch (e) {
			}
		}
		else {
			try {
				allFrames[0].paths[0].pathPoints[0].join(allFrames[n].paths[0].pathPoints[0], JoinOptions.COMBINE);
			}
			catch (e) {
			}
		}
	}
}

// der Kontur ein paar Attribute zuweisen
allFrames[0].appliedObjectStyle = curDoc.objectStyles.item(0);
allFrames[0].properties = {strokeColor:"Black", strokeWeight:strW, strokeTint:strT, 
	strokeAlignment:StrokeAlignment.CENTER_ALIGNMENT, endCap:EndCap.ROUND_END_CAP};

// die Richtung umkehren
allFrames[0].paths[0].reverse ();

// "im Uhrzeigersinn" (= Vorgabe) oder "gegen den Uhrzeigersinn"
if (dirDec == 0) {
	var dirTxt = "im Uhrzeigersinn";
}
else if (dirDec == 1) {
	var dirTxt = "gegen den Uhrzeigersinn";
	// Bezugspunkt in der Mitte auswhlen
	curDoc.layoutWindows[0].transformReferencePoint = AnchorPoint.centerAnchor;
	// die Spirale spiegeln
	allFrames[0].flipItem(Flip.HORIZONTAL);
}

// den Eintrag ins Etikett vornehmen
allFrames[0].label = "Anzahl Halbbogen: " + numVal + "\rBogenhhe ndern: " + pcHeig + "%\rBreitennderung: " + pcWidt +"%\rRichtung: " + dirTxt;

// die Auswahl aufheben
app.selection = null;

// die Funktion zum Zurcksetzen der Einstellungen aufrufen
reStoreSettings();


////////////////////////////// die Funktionen  ////////////////////////////////////////////////////

// die Funktion, welche die Informationen vorbereitet /////////////////////////////////////////////
function getPrefs() {
	var allPrefs = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Spirale3D401.txt");
	}
	else {
		var f = new File("~/Library/Preferences/Spirale3D401.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// den Dialog vorbereiten und anzeigen ////////////////////////////////////////////////////////////
function displayDialog() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth = 152;
	var fieldWidth =  36;
	var aDialog = app.dialogs.add({name:"Spirale3D"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Kontur-Strke:", minWidth:labelWidth-10});
						var weightField = realEditboxes.add({editValue:strW, minimumValue:0.1, maximumValue:99, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"pt", minWidth:12});
						staticTexts.add({staticLabel:"", minWidth:0});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Kontur-Tonwert:", minWidth:labelWidth-10});
						var tintField = realEditboxes.add({editValue:strT, minimumValue:1, maximumValue:100, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"%", minWidth:12});
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Anzahl Halbbogen:", minWidth:labelWidth-10});
						var numField = integerEditboxes.add({editValue:numV, minimumValue:1, maximumValue:123, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"", minWidth:19});
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Bogenhhe ndern:", minWidth:labelWidth-10});
						var pcHeightField = realEditboxes.add({editValue:pcHg, minimumValue:0.1, maximumValue:300, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"%", minWidth:12});
						staticTexts.add({staticLabel:"", minWidth:2});
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Nach jeder Umdrehung die ..."});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"... Breite so ndern:", minWidth:labelWidth-10});
						var pcWidthField = realEditboxes.add({editValue:pcWd, minimumValue:50, maximumValue:150, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"%", minWidth:12});
						staticTexts.add({staticLabel:"", minWidth:2});
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Laufrichtung:", minWidth:50});
						staticTexts.add({staticLabel:" ", minWidth:118});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:" ", minWidth:8});
						with(dirButtons = radiobuttonGroups.add()){
							radiobuttonControls.add({staticLabel:"im Uhrzeigersinn", checkedState:ck01});
							radiobuttonControls.add({staticLabel:"gegen den Uhrzeigersinn", checkedState:ck02});
						}
					}
				}
			}
		}
	}
	if(aDialog.show() == true) {
		// die Eingaben auswerten
		var strWght = weightField.editValue;
		var strTint = tintField.editValue;
		var numVal  = numField.editValue;
		var pcHeigh = pcHeightField.editValue;
		var pcWidth = pcWidthField.editValue;
		var dirDec  = dirButtons.selectedButton;
		// den Dialog entfernen
		aDialog.destroy();
		// die neue Vorgabenliste
		var prefsList = new Array (strWght, strTint, numVal, pcHeigh, pcWidth, dirDec);
		// in eine Textkette verwandeln
		var prefString = prefsList.join("\n");
		// zur Funktion schicken, welche das Ergebnis in eine Datei schreibt
		writeResult(prefString);
		// das Ergebnis zum Aufruf zurckschicken
		return [strWght, strTint, numVal, pcHeigh, pcWidth, dirDec];
	}
	else{
		// wenn "Abbrechen", den Dialog entfernen ...
		aDialog.destroy();
		// ... die Funktion aufrufen, welche die Einstellungen zurcksetzt ...
		reStoreSettings();
		// ... und die Ausfhrung abbrechen
		exit();
	}
}

// das Ergebnis in eine Datei schreiben ///////////////////////////////////////////////////////////
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Spirale3D401.txt");
	}
	else {
		var f = File("~/Library/Preferences/Spirale3D401.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// eventuell genderte Einstellungen zurcksetzen /////////////////////////////////////////////////
function reStoreSettings() {
	// Masseinheiten, Linealursprung und Nullpunkt zurcksetzen
	curDoc.viewPreferences.horizontalMeasurementUnits = hM;
	curDoc.viewPreferences.verticalMeasurementUnits = vM;
	curDoc.viewPreferences.rulerOrigin = rO;
	curDoc.zeroPoint = zP;
	curDoc.layoutWindows[0].transformReferencePoint = tR;
}